<#ibizinclude>
../@MACRO/CONTROL/LANGBASE.vue.ftl
</#ibizinclude>
<#assign ListContent>
<div class="app-list-item-content">
    <div class="item-icon">
        <template v-if="item.srficon">
            <img :src="item.srficon" />
        </template>
        <template v-else>
            <img src="/assets/img/noimage.png"/>
        </template>
    </div>
    <template>
        <div class="item-content-text">
            <div class="item-title">
                <span >{{item.srfmajortext}}</span>
            </div>
            <div class="item-description">
                <span v-if="item.srfdescription" class="item-subtext" :title="item.srfdescription">{{ item.srfdescription }}</span>
            </div>
        </div>
    </template>
</div>
<div v-if="item.srfdate" class="app-list-item-date">
    <span class="date">{{ item.srfdate }}</span>
</div>
</#assign>
<template>  
<#if ctrl.getBatchPSDEToolbar?? && ctrl.getBatchPSDEToolbar()??>
<div style="overflow:auto;">
</#if>
    <div :class="['app-list',<#if ctrl.getPSSysCss?? && ctrl.getPSSysCss()??><#assign singleCss = ctrl.getPSSysCss()>'${singleCss.getCssName()}',</#if>this.items.length > 0 ? '' : 'app-list-empty' ]">
<#if ctrl.render??>
            ${ctrl.render.code}
<#else>
        <div v-if="items.length > 0">
<#if ctrl.isEnableGroup?? && !ctrl.isEnableGroup()>                 
            <div v-for = "item in items" :key="item.srfkey"  :class="['app-list-item', {'isSelect': item.isselected === true ? true : false}]" @click="handleClick(item)"  @dblclick="handleDblClick(item)">
  <#if ctrl.getItemPSLayoutPanel()??>
    <#assign panel = ctrl.getItemPSLayoutPanel()>
                <@ibizindent blank=16>
                ${P.getCtrlCode(panel, 'CONTROL.html').code}
                </@ibizindent>
  <#elseif ctrl.itemRender??>
                ${ctrl.itemRender.code}
  <#else>
                ${ListContent}
                <div class="app-list-item-action">
                    <template v-for="(action,index) in Object.keys(actionModel)">
                        <a :key="index" style="display: inline-block;margin: 0 12px;" v-show="item[action].visabled" :disabled="item[action].disabled" @click="uiAction(item, action, $event)">
                            <i :class="actionModel[action].icon" style="margin-right:2px;"></i>
                            <span>{{actionModel[action].caption}}</span>
                        </a>
                    </template>
                </div>
  </#if>
            </div>
<#elseif ctrl.isEnableGroup?? && ctrl.isEnableGroup()>
            <el-collapse>
               <el-collapse-item v-for="(group,index) in groupData" :key="index">
                    <template slot="title">
                    <div style="margin: 0 0 0 12px;"><b>{{group.group}}</b></div>
                    </template>
                    <div v-if="group.children.length > 0" style="margin: 0 0 0 32px;">
                        <div v-for="item in group.children" :key="item.srfkey"  :class="['app-list-item', {'isSelect': item.isselected === true ? true : false}]" @click="handleClick(item)"  @dblclick="handleDblClick(item)">
                        <#if ctrl.getItemPSLayoutPanel()??>
                            <#assign panel = ctrl.getItemPSLayoutPanel()>
                                <@ibizindent blank=16>
                                ${P.getCtrlCode(panel, 'CONTROL.html').code}
                                </@ibizindent>
                        <#elseif ctrl.itemRender??>
                                ${ctrl.itemRender.code}
                        <#else>
                                ${ListContent}
                                <div calss="app-list-item-action">
                                    <template v-for="(action,index) in Object.keys(actionModel)">
                                        <a :key="index" style="display: inline-block;margin: 0 12px;" v-show="item[action].visabled" :disabled="item[action].disabled" @click="uiAction(item, action, $event)">
                                            <i :class="actionModel[action].icon" style="margin-right:2px;"></i>
                                            <span>{{actionModel[action].caption}}</span>
                                        </a>
                                    </template>
                                </div>
                        </#if>
                        </div>
                    </div>
                    <div v-else style="text-align: center;">
                        {{ $t('<#if langbase??>${langbase}.nodata</#if>') }}
                    </div>
                </el-collapse-item>
            </el-collapse>
</#if>
            <template v-if="isScrollBar">
            <div v-if="totalRecord>items.length" class="loadmore">{{ this.$t('app.commonWords.loadmore') }}</div>
            <div v-else class="loadmore">{{ this.$t('app.commonWords.nomore') }}</div>
            </template>
        </div>
        <div v-else>
            {{ $t('<#if langbase??>${langbase}.nodata</#if>') }}
            <#if ctrl.getQuickPSDEToolbar?? && ctrl.getQuickPSDEToolbar()??>
            <span class="quick-toolbar">
                <#assign quickToolbar = ctrl.getQuickPSDEToolbar()/>
                <@ibizindent blank=12>
                ${P.getCtrlCode(quickToolbar, 'CONTROL.html').code}
                </@ibizindent>
            </span>
            </#if>
        </div>
        <el-backtop target=".content-container .app-list"></el-backtop>
</#if>
    </div>
<#if ctrl.getBatchPSDEToolbar?? && ctrl.getBatchPSDEToolbar()??>
    <row class='list-pagination' v-if="selections.length > 0">
        <span class="batch-toolbar">
          <#assign batchToolbar = ctrl.getBatchPSDEToolbar()/>
          <@ibizindent blank=12>
        ${P.getCtrlCode(batchToolbar, 'CONTROL.html').code}
          </@ibizindent>
        </span>
    </row>
</div>
</#if>
</template>
<#assign import_block>
import CodeListService from "@/codelist/codelist-service";
</#assign>
<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER-BASE.vue.ftl
</#ibizinclude>

    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */  
    public codeListService:CodeListService = new CodeListService();

    /**
     * 界面UI服务对象
     *
     * @type {${srfclassname('${appde.getCodeName()}')}UIService}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */  
    public appUIService:${srfclassname('${appde.getCodeName()}')}UIService = new ${srfclassname('${appde.getCodeName()}')}UIService();

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getDatas(): any[] {
        return this.selections;
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getData(): any {
        return null;
    }

    /**
     * 是否默认选中第一条数据
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop({ default: false }) public isSelectFirstDefault!: boolean;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public createAction!: string;

    /**
     * 部件行为--remove
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public removeAction!: string;

    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public updateAction!: string;
    
    /**
     * 部件行为--fetch
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public fetchAction!: string;

    /**
     * 父引用类型
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop({default:true}) public parentType: any;;

<#if view.getPSAppViewLogics?? && view.getPSAppViewLogics()??>
  <#list view.getPSAppViewLogics() as logic>
    <#if logic.getPFLogicCodeType() == 'APP_NEWDATA'>
    /**
     * 打开新建数据视图
     *
     * @type {any}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public newdata: any;
    </#if>
    <#if logic.getPFLogicCodeType() == 'APP_OPENDATA'>
    /**
     * 打开编辑数据视图
     *
     * @type {any}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public opendata: any;
    </#if>
  </#list>
</#if>

    /**
     * this引用
     *
     * @type {number}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public thisRef: any = this;

<#if ctrl.isEnableGroup?? && ctrl.isEnableGroup()>
    /**
     * 分组属性
     * 
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public groupField: string = "<#if ctrl.getGroupPSDEField?? && ctrl.getGroupPSDEField()??>${ctrl.getGroupPSDEField().getCodeName()?lower_case}</#if>";

    /**
     * 分组属性是否配置代码表
     * 
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public groupFieldCodelist: boolean = <#if ctrl.getGroupPSDEField()?? && ctrl.getGroupPSDEField().getPSCodeList?? && ctrl.getGroupPSDEField().getPSCodeList()??>true<#else>false</#if>;

    /**
     * 分组数据
     * 
     * @type {Array<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public groupData: Array<any> = [];

    /**
     * 分组模式
     * 
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public groupMode: string = "<#if ctrl.getGroupMode?? && ctrl.getGroupMode()??>${ctrl.getGroupMode()}</#if>";

    /**
     * 分组方法
     * 
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public group(){
        let _this:any = this;
        if(_this.drawGroup && _this.drawGroup instanceof Function && Object.is(_this.groupMode,"AUTO")){
            _this.drawGroup();
        }else if(_this.drawCodelistGroup && _this.drawCodelistGroup instanceof Function && Object.is(_this.groupMode,"CODELIST")){
            _this.drawCodelistGroup();
        }
    }
</#if>

<#if ctrl.getGroupMode?? && ctrl.getGroupMode() == 'CODELIST'>

    /**
     * 分组代码表
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */ 
    public groupCodelist: any = {<#if ctrl.getGroupPSCodeList?? && ctrl.getGroupPSCodeList()??>type:'${ctrl.getGroupPSCodeList().getCodeListType()}',tag:'${ctrl.getGroupPSCodeList().getCodeName()}'</#if>};

    /**
     * 根据分组代码表绘制分组列表
     * 
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public async drawCodelistGroup(){
        let groups: Array<any> = [];
        let fields: Array<any> = [];
        let groupTree:Array<any> = [];
        let data:Array<any> = [...this.items];
        if(Object.keys(this.groupCodelist).length > 0){
            let groupCodelist: any = await this.codeListService.getDataItems(this.groupCodelist);
            groups = Util.deepCopy(groupCodelist);

        }
        if(groups.length == 0){
            console.warn("分组数据无效");
        }
        groups.forEach((group: any,i: number)=>{
            let children:Array<any> = [];
            data.forEach((item: any,j: number)=>{
                if(this.groupFieldCodelist){
                    if(Object.is(group.label,item[this.groupField])) {
                        children.push(item);
                    }
                }else if(Object.is(group.value,item[this.groupField])){
                    children.push(item);
                }
            });
            const tree: any ={
                group: group.label,
                children: children
            }
            groupTree.push(tree);
        });
        let child:Array<any> = [];
        data.forEach((item: any)=>{
            let i: number = 0;
            if(this.groupFieldCodelist){
                i = groups.findIndex((group: any)=>Object.is(group.label,item[this.groupField]));
            }else{
                i = groups.findIndex((group: any)=>Object.is(group.value,item[this.groupField]));
            }
            if(i < 0){
                child.push(item);
            }
        })
        const Tree: any = {
            group: this.$t('app.commonWords.other'),
            children: child
        }
        if(child && child.length > 0){
            groupTree.push(Tree);
        }
        this.groupData = [...groupTree];
    }
</#if>

<#if ctrl.getGroupMode?? && ctrl.getGroupMode() == 'AUTO'>
    /**
     * 绘制分组列表
     * 
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public async drawGroup(){
        let data:Array<any> = [...this.items];
        let groups:Array<any> = [];
        let fields: Array<any> = [];
        data.forEach((item: any)=>{
            if(item.hasOwnProperty(this.groupField)){
                groups.push(item[this.groupField]);
            }
        });
        groups = [...new Set(groups)];
        if(groups.length == 0){
            console.warn("分组数据无效");
        }
        let groupTree:Array<any> = [];
        groups.forEach((group: any,i: number)=>{
            let children:Array<any> = [];
            data.forEach((item: any,j: number)=>{
                if(Object.is(group,item[this.groupField])){
                    children.push(item);
                }
            });
            group = group ? group : this.$t('app.commonWords.other');
            const tree: any ={
                group: group,
                children: children
            }
            groupTree.push(tree);
        });
        this.groupData = [...groupTree];
    }
</#if>

    <#if ctrl.getQuickPSDEToolbar?? && ctrl.getQuickPSDEToolbar()??>
      <#assign quickToolbar = ctrl.getQuickPSDEToolbar()/>
      ${P.getCtrlCode(quickToolbar, 'CONTROL.vue').code}
    </#if>

    <#if ctrl.getBatchPSDEToolbar?? && ctrl.getBatchPSDEToolbar()??>
      <#assign batchToolbar = ctrl.getBatchPSDEToolbar()/>
      ${P.getCtrlCode(batchToolbar, 'CONTROL.vue').code}
    </#if>

    /**
     * 当前页
     *
     * @type {number}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public curPage: number = 1;

    /**
     * 数据
     *
     * @type {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public items: any[] = [];

    /**
     * 是否支持分页
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public isEnablePagingBar: boolean = true;

    /**
     * 分页条数
     *
     * @type {number}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public limit: number = ${ctrl.getPagingSize()?c};

    /**
     * 总条数
     *
     * @type {number}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public totalRecord: number = 0;

    /**
     * 加载的数据是否附加在items之后
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public isAddBehind:boolean = false;

    /**
     * 是否有滚动条
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public isScrollBar: boolean = false;

    /**
     * 排序方向
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */    
    public sortDir:string = '<#if ctrl.getMinorSortDir()??>${ctrl.getMinorSortDir()?lower_case}</#if>';

    /**
     * 排序字段
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */    
    public sortField: string = '<#if ctrl.getMinorSortPSDEF()??>${ctrl.getMinorSortPSDEF().getCodeName()?lower_case}</#if>';

    /**
     * 选中数组
     * @type {Array<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public selections: Array<any> = [];

    /**
     * 应用状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public appStateEvent: Subscription | undefined;

     /**
     * Vue声明周期，组件挂载完毕
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public mounted () {
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public afterMounted () {
        const loadMoreCallBack:any = this.throttle(this.loadMore,3000);
        <#if ctrl.getBatchPSDEToolbar?? && ctrl.getBatchPSDEToolbar()??>
        let listDom = this.$el.children[0];
        listDom.addEventListener('scroll', ()=> {
            if(this.$el.scrollHeight > this.$el.clientHeight) {
                this.isScrollBar = true;
            } else {
                this.isScrollBar = false;
            }
            if( this.$el.scrollTop +  this.$el.clientHeight  >=  this.$el.scrollHeight) {
                loadMoreCallBack();
            }
        })
        <#else>
        this.$el.addEventListener('scroll', ()=> {
            if(this.$el.scrollHeight > this.$el.clientHeight) {
                this.isScrollBar = true;
            } else {
                this.isScrollBar = false;
            }
            if( this.$el.scrollTop +  this.$el.clientHeight  >=  this.$el.scrollHeight) {
                loadMoreCallBack();
            }
        })
        </#if>
    }

    /**
     * Vue声明周期，组件创建完毕
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public created() {
        this.afterCreated()
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof ${srfclassname('${ctrl.codeName}')}Base
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(this.name, tag)) {
                    return;
                }
                if (Object.is(action,'load')) {
                    this.curPage = 1;
                    this.items = [];
                    this.load(data);
                }
                if (Object.is(action,'refresh')) {
                    this.refresh(data);
                }
            });
        }
        if(AppCenterService && AppCenterService.getMessageCenter()){
            this.appStateEvent = AppCenterService.getMessageCenter().subscribe(({ name, action, data }) =>{
                if(!Object.is(name,"${ctrl.getPSAppDataEntity().getCodeName()}")){
                    return;
                }
                if(Object.is(action,'appRefresh')){
                    this.refresh([data]);
                }
            })
        }
    }    

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if(this.appStateEvent){
            this.appStateEvent.unsubscribe();
        }
        <#if destroyed_block??>
        ${destroyed_block}
        </#if>
    }    

    /**
    * 加载更多
    *
    * @memberof ${srfclassname('${ctrl.codeName}')}Base
    */
    public loadMore(){
        if(this.totalRecord>this.items.length){
            this.curPage = ++this.curPage;
            this.isAddBehind = true;
            this.load({});
        }
    }

    /**
     * 刷新
     *
     * @param {*} [args={}]
     * @memberof Main
     */
    public refresh(args?: any) {
        this.isAddBehind = true;
        this.load(args);
    }

    /**
     * 列表数据加载
     *
     * @public
     * @param {*} [arg={}]
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public load(opt: any = {}): void {
        if(!this.fetchAction){
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: '${view.getName()}' + (this.$t('app.list.notConfig.fetchAction') as string) });
            return;
        }        
        const arg: any = {...opt};
        const page: any = {};
        if (this.isEnablePagingBar) {
            Object.assign(page, { page: this.curPage-1, size: this.limit });
        }
        // 设置排序
        if (!Object.is(this.sortDir, '') && !Object.is(this.sortField, '')) {
          const sort: string = this.sortField+","+this.sortDir;
            Object.assign(page, { sort: sort });
        }
        Object.assign(arg, page);
        const parentdata: any = {};
        this.$emit('beforeload', parentdata);
        Object.assign(arg, parentdata);
        let tempViewParams:any = parentdata.viewparams?parentdata.viewparams:{};
        if(this.viewparams){
            Object.assign(tempViewParams,JSON.parse(JSON.stringify(this.viewparams)));
        }
        Object.assign(arg,{viewparams:tempViewParams});
        const post: Promise<any> = this.service.search(this.fetchAction, this.context?JSON.parse(JSON.stringify(this.context)):{}, arg, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response || response.status !== 200) {
                if (response.data && response.data.message) {
                    this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: response.data.message });
                }
                return;
            }
            const data: any = response.data;
            if(!this.isAddBehind){
                this.items = [];
            }
            if (data && data.length > 0) {
                let datas = JSON.parse(JSON.stringify(data));
                datas.map((item: any) => {
                    Object.assign(item, { isselected: false });
                });
                this.totalRecord = response.total;
                this.items.push(...datas);
                this.items = this.arrayNonRepeatfy(this.items);
            }
            this.isAddBehind = false;
            this.items.forEach((item: any) => {
                Object.assign(item,this.getActionState(item));    
            })
            this.$emit('load', this.items);
            //在导航视图中，如已有选中数据，则右侧展开已选中数据的视图，如无选中数据则默认选中第一条
            if(this.isSelectFirstDefault){
                if(this.selections && this.selections.length > 0){
                    this.selections.forEach((select: any)=>{
                        const index = this.items.findIndex((item:any) => Object.is(item.srfkey,select.srfkey));
                        if(index != -1){
                            this.handleClick(this.items[index]);
                        }
                    })
                }else{
                    this.handleClick(this.items[0]);
                } 
            }
            <#if ctrl.isEnableGroup?? && ctrl.isEnableGroup()>
            this.group();
            </#if>
        }, (response: any) => {
            if (response && response.status === 401) {
                return;
            }
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: response.data && response.data.message ? response.data.message : "" });
        });
    }

    /**
     * 列表数据去重
     *
     * @param {Array<any>} [arr]
     * @returns {void}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public arrayNonRepeatfy(arr:Array<any>) {
        let map = new Map();
        let array = new Array();
        for (let i = 0; i < arr.length; i++) {
            map .set(arr[i].srfkey, arr[i]); 
        }
        map.forEach((value:any, key:string, map:any) => {
            array.push(value);
        });
        return array ;
    }

    /**
     * 节流
     *
     * @param {Array<any>} [arr]
     * @returns {void}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public throttle(fn:any, wait:number){
        let time = 0;
        return () =>{
          let now = Date.now()
          let args = arguments;
          if(now - time > wait){
            fn.apply(this, args)
            time = now;
          }
        }
    }

    /**
     * 删除
     *
     * @param {any[]} datas
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public async remove(datas: any[]): Promise<any> {
        if(!this.removeAction){
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: '${view.getName()}' + (this.$t('app.list.notConfig.removeAction') as string) });
            return;
        }
        if (datas.length === 0) {
            return;
        }
        let dataInfo = '';
        datas.forEach((record: any, index: number) => {
            let srfmajortext = record.srfmajortext;
            if (index < 5) {
                if (!Object.is(dataInfo, '')) {
                    dataInfo += '、';
                }
                dataInfo += srfmajortext;
            } else {
                return false;
            }
        });

        if (datas.length < 5) {
            dataInfo = dataInfo + ' 共' + datas.length + '条数据';
        } else {
            dataInfo = dataInfo + '...' + ' 共' + datas.length + '条数据';
        }

        const removeData = () => {
            let keys: any[] = [];
            datas.forEach((data: any) => {
                keys.push(data.srfkey); 
            });
            let _removeAction = keys.length > 1 ? 'removeBatch' : this.removeAction ;
            const context:any = JSON.parse(JSON.stringify(this.context));
            const post: Promise<any> = this.service.delete(_removeAction,Object.assign(context,{ ${ctrl.getPSAppDataEntity().codeName?lower_case}: keys.join(';') }),Object.assign({ ${ctrl.getPSAppDataEntity().codeName?lower_case}: keys.join(';') },{viewparams:this.viewparams}), this.showBusyIndicator);
            return new Promise((resolve: any, reject: any) => {
                post.then((response: any) => {
                    if (!response || response.status !== 200) {
                        this.$Notice.error({ title: '', desc: (this.$t('app.commonWords.delDataFail') as string) + ',' + response.info });
                        return;
                    } else {
                        this.$Notice.success({ title: '', desc: (this.$t('app.commonWords.deleteSuccess') as string) });
                    }
                    //删除items中已删除的项
                    datas.forEach((data: any) => {
                        this.items.some((item:any,index:number)=>{
                            if(Object.is(item.srfkey,data.srfkey)){
                                this.items.splice(index,1);
                                <#if ctrl.isEnableGroup?? && ctrl.isEnableGroup()>
                                this.group();
                                </#if>
                                return true;
                            }
                        });
                    });
                    this.$emit('remove', null);
                    this.selections = [];
                    resolve(response);
                }).catch((response: any) => {
                    if (response && response.status === 401) {
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: (this.$t('app.commonWords.sysException') as string) });
                        reject(response);
                        return;
                    }
                    reject(response);
                });
            });
        }

        dataInfo = dataInfo.replace(/[null]/g, '').replace(/[undefined]/g, '').replace(/[ ]/g, '');
        this.$Modal.confirm({
            title: (this.$t('app.commonWords.warning') as string),
            content: (this.$t('app.list.confirmDel') as string) + ' ' + dataInfo + '，' + (this.$t('app.list.notRecoverable') as string) ,
            onOk: () => {
                removeData();
            },
            onCancel: () => { }
        });
        return removeData;
    }

    /**
     * 保存
     *
     * @param {*} $event
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public async save(args: any[], params?: any, $event?: any, xData?: any){
        let _this = this;
        let successItems:any = [];
        let errorItems:any = [];
        let errorMessage:any = [];
        for (const item of _this.items) {
            try {
                if(Object.is(item.rowDataState, 'create')){
                    if(!this.createAction){
                        this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: '${view.getName()}' + (this.$t('app.list.notConfig.createAction') as string) });
                    }else{
                      Object.assign(item,{viewparams:this.viewparams});
                      let response = await this.service.add(this.createAction, JSON.parse(JSON.stringify(this.context)),item, this.showBusyIndicator);
                      successItems.push(JSON.parse(JSON.stringify(response.data)));
                    }
                }else if(Object.is(item.rowDataState, 'update')){
                    if(!this.updateAction){
                        this.$Notice.error({ title: (this.$t('app.commonWords.warning') as string), desc: '${view.getName()}' + (this.$t('app.list.notConfig.updateAction') as string) });
                    }else{
                        Object.assign(item,{viewparams:this.viewparams});
<#if de??>
                        if(item.${appde.getCodeName()?lower_case}){
                            Object.assign(this.context,{${appde.getCodeName()?lower_case}:item.${appde.getCodeName()?lower_case}});
                        }
</#if>
                        let response = await this.service.add(this.updateAction,JSON.parse(JSON.stringify(this.context)),item, this.showBusyIndicator);
                        successItems.push(JSON.parse(JSON.stringify(response.data)));
                    }
                }
            } catch (error) {
                errorItems.push(JSON.parse(JSON.stringify(item)));
                errorMessage.push(error);
            }
        }
        this.$emit('save', successItems);
        this.refresh();
        if(errorItems.length === 0){
            this.$Notice.success({ title: '', desc: (this.$t('app.commonWords.saveSuccess') as string) });
        }else{
          errorItems.forEach((item:any,index:number)=>{
            this.$Notice.error({ title: (this.$t('app.commonWords.saveFailed') as string), desc: item.majorentityname+ (this.$t('app.commonWords.saveFailed') as string) + '!' });
            console.error(errorMessage[index]);
          });
        }
        return successItems;
    }

    /**
     * 面板数据变化处理事件
     * @param {any} item 当前列数据
     * @param {any} $event 面板事件数据
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public onPanelDataChange(item:any,$event:any) {
        Object.assign(item, $event, {rowDataState:'update'});
    }

    /**
     * 选择数据
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     *
     */
    public handleClick(args: any) {
        if(this.parentType && this.parentType === "listExpBar") {
            const flag = args.isselected;
            this.clearSelection();
            if(!flag) {
                args.isselected = !args.isselected;
            } else {
                args.isselected = flag;
            }
        } else {
            args.isselected = !args.isselected;
        }
        this.selectchange();
    }

    /**
     * 双击数据
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     *
     */
    public handleDblClick(args: any) {
        this.$emit('rowdblclick', args);
    }

    /**
     * 触发事件
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     *
     */
    public selectchange() {
        this.selections = [];
        this.items.map((item: any) => {
            if (item.isselected) {
                this.selections.push(item);
            }
        });
        this.$emit('selectionchange', this.selections);
    }

    /**
     * 清除当前所有选中状态
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public clearSelection(){
        this.items.map((item: any) => {
            Object.assign(item, { isselected: false });
        }); 
    }

    /**
     * 操作栏模型数据
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */ 
    public actionModel:any ={
    <#if ctrl.getPSDEListItems?? && ctrl.getPSDEListItems()??>
    <#list ctrl.getPSDEListItems() as listItem>
        <#if listItem.getPSDEUIActionGroup?? && listItem.getPSDEUIActionGroup()??>
        <#assign UIActionGrop = listItem.getPSDEUIActionGroup() />
        <#if UIActionGrop.getPSUIActions?? && UIActionGrop.getPSUIActions()??>
        <#list UIActionGrop.getPSUIActions() as UIAction >
         "${UIAction.getUIActionTag()}":{name:"${UIAction.getUIActionTag()}",icon:"<#if UIAction.getPSSysImage()??><#assign img=UIAction.getPSSysImage() /><#if img.getCssClass()?? && (img.getCssClass()?length gt 0)>${img.getCssClass()}</#if></#if>",caption:"${UIAction.getCaption()}",disabled: false, visabled: true,noprivdisplaymode:<#if UIAction.getNoPrivDisplayMode(view)??>${UIAction.getNoPrivDisplayMode(view)}</#if>,dataaccaction: "<#if UIAction.getDataAccessAction()??>${UIAction.getDataAccessAction()}</#if>", actiontarget: "${UIAction.getActionTarget()}"},
        </#list>
        </#if>
        </#if>
    </#list>
    </#if>
    };

    /**
     * 操作列界面行为
     *
     * @param {*} data
     * @param {*} tag
     * @param {*} $event
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
	public uiAction(data: any, tag: any, $event: any) {
        $event.stopPropagation();
        <#if ctrl.getPSAppViewLogics()??>
        <#list ctrl.getPSAppViewLogics() as logic>
        <#if logic.getPSAppViewUIAction().getPSUIAction()??>
        <#assign action = logic.getPSAppViewUIAction().getPSUIAction()>
        if(Object.is('${action.getUIActionTag()}', tag)) {
            this.${logic.getName()}(data, tag, $event);
        }
        </#if>
        </#list>
        </#if>
    }

    /**
     * 获取界面行为权限状态
     *
     * @param {*} data 当前列表行数据
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getActionState(data:any){
        let tempActionModel:any = JSON.parse(JSON.stringify(this.actionModel));
        let targetData:any = this.transformData(data);
        ViewTool.calcActionItemAuthState(targetData,tempActionModel,this.appUIService);
        return tempActionModel;
    }

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_BOTTOM-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL-BASE.style.ftl
</#ibizinclude>