<#ibizinclude>
../@MACRO/MODEL/MODEL_HEADER.ts.ftl
</#ibizinclude>

	/**
	 * 地图项类型
	 *
	 * @returns {any[]}
	 * @memberof ${srfclassname('${ctrl.getCodeName()}')}${srfclassname('${ctrl.name}')}Mode
	 */
	public itemType: string = "";

	/**
	 * 获取数据项集合
	 *
	 * @returns {any[]}
	 * @memberof ${srfclassname('${ctrl.getCodeName()}')}${srfclassname('${ctrl.name}')}Mode
	 */
	public getDataItems(): any[] {
        let dataItems: any = [
<#--  关联主实体的主键  -->
<#if ctrl.getPSAppDataEntity()??>
    <#assign appDataEntity = ctrl.getPSAppDataEntity() />
    <#if appDataEntity.isMajor() == false && appDataEntity.getMinorPSAppDERSs()??>
        <#list appDataEntity.getMinorPSAppDERSs() as minorAppDERSs>
            <#if minorAppDERSs.getMajorPSAppDataEntity()??>
            <#assign majorAppDataEntity = minorAppDERSs.getMajorPSAppDataEntity() />
            {
                name: '${majorAppDataEntity.getCodeName()?lower_case}',
                prop: '${majorAppDataEntity.getKeyPSAppDEField().getCodeName()?lower_case}'
            },
            </#if>
        </#list>
    </#if>
</#if>
            {
                name: 'itemType',
            },
        ];
        switch (this.itemType) {
    <#--  地图项实体映射  -->
<#if ctrl.getPSSysMapItems()??>
    <#list ctrl.getPSSysMapItems() as mapItem>
        <#if mapItem.getPSAppDataEntity()??>
        case "${mapItem.getItemType()?lower_case}":
            dataItems = 
                [
                    ...dataItems,
                    {
                        name: 'longitude',
                        prop: '${mapItem.getLongitudePSAppDEField().getCodeName()?lower_case}'
                    },
                    {
                        name: 'latitude',
                        prop: '${mapItem.getLatitudePSAppDEField().getCodeName()?lower_case}'
                    },
                    {
                        //  高度
                        name: 'height',
                        prop: '<#if mapItem.getAltitudePSAppDEField?? && mapItem.getAltitudePSAppDEField()??>${mapItem.getAltitudePSAppDEField().getCodeName()?lower_case}</#if>'
                    },
                    {
                        //  背景颜色
                        name: 'height',
                        prop: '<#if mapItem.getBKColorPSAppDEField?? && mapItem.getBKColorPSAppDEField()??>${mapItem.getBKColorPSAppDEField().getCodeName()?lower_case}</#if>'
                    },
                    {
                        //  提示
                        name: 'tips',
                        prop: '<#if mapItem.getTipsPSAppDEField?? && mapItem.getTipsPSAppDEField()??>${mapItem.getTipsPSAppDEField().getCodeName()?lower_case}</#if>'
                    },
                    {
                        //  文本值
                        name: 'text',
                        prop: '<#if mapItem.getTextPSAppDEField?? && mapItem.getTextPSAppDEField()??>${mapItem.getTextPSAppDEField().getCodeName()?lower_case}</#if>'
                    },
                    {
                        //  排序
                        name: 'height',
                        prop: '<#if mapItem.getOrderValuePSAppDEField?? && mapItem.getOrderValuePSAppDEField()??>${mapItem.getOrderValuePSAppDEField().getCodeName()?lower_case}</#if>'
                    },
                    {
                        //  字体颜色
                        name: 'fontcolor',
                        prop: '<#if mapItem.getColorPSAppDEField?? && mapItem.getColorPSAppDEField()??>${mapItem.getColorPSAppDEField().getCodeName()?lower_case}</#if>'
                    },
                    {
                        //  数据项内容
                        name: 'content',
                        prop: '<#if mapItem.getContentPSDEField?? && mapItem.getContentPSDEField()??>${mapItem.getContentPSDEField().getCodeName()?lower_case}</#if>'
                    },
                    {
                        //  分组
                        name: 'group',
                        prop: '<#if mapItem.getGroupPSAppDEField?? && mapItem.getGroupPSAppDEField()??>${mapItem.getGroupPSAppDEField().getCodeName()?lower_case}</#if>'
                    },
                    {
                        //  图标
                        name: 'icon',
                        prop: '<#if mapItem.getIconPSAppDEField?? && mapItem.getIconPSAppDEField()??>${mapItem.getIconPSAppDEField().getCodeName()?lower_case}</#if>'
                    },
                ];
            break;
        </#if>
    </#list>
</#if>
        }
        return dataItems;
	}

<#ibizinclude>
../@MACRO/MODEL/MODEL_BOTTOM.ts.ftl
</#ibizinclude>