<#ibizinclude>
../@MACRO/CONTROL/LANGBASE.vue.ftl
</#ibizinclude>
<template>
<#if ctrl.render??><#t>
    ${ctrl.render.code}
<#else><#t>
    <div class="app-data-view<#if ctrl.getPSSysCss?? && ctrl.getPSSysCss()??><#assign singleCss = ctrl.getPSSysCss()> ${singleCss.getCssName()}</#if>">
  <#assign hasSortBar = false />
  <#if ctrl.getPSDEDataViewDataItems?? && ctrl.getPSDEDataViewDataItems()??>
    <#list ctrl.getPSDEDataViewDataItems() as dataItem>
      <#if dataItem.getPSAppDEField?? && dataItem.getPSAppDEField()?? && !dataItem.getPSAppDEField().isKeyField()>
        <#assign hasSortBar = true />
      </#if>
    </#list>
  </#if>
  <#if hasSortBar>
    <app-sort-bar
        :sortModel="sortModel"
        :sortField="sortField"
        :sortDir="sortDir"
        entityName="${appde.getCodeName()?lower_case}"
        @clickSort="(val) => {sortClick(val);}">
    </app-sort-bar>
  </#if>
        <row class="data-view-container" v-show="items.length > 0" :gutter="20" type="flex" justify="start" style="margin:0px;">
        <#if ctrl.isEnableGroup?? && !ctrl.isEnableGroup()>
            <a v-for="(item,index) in items" :key="index" :href = "item.starturl">
                <i-col <#if ctrl.getCardColLG() gt 0> :lg="${ctrl.getCardColLG()?c}"</#if><#if ctrl.getCardColMD() gt 0> :md="${ctrl.getCardColMD()?c}"</#if><#if ctrl.getCardColSM() gt 0> :sm="${ctrl.getCardColSM()?c}"</#if><#if ctrl.getCardColXS() gt 0> :xs="${ctrl.getCardColXS()?c}"</#if> style="<#if ctrl.getCardHeight() gt 0>height: ${ctrl.getCardHeight()?c}<#else>min-height: 170</#if>px;<#if ctrl.getCardWidth() gt 0> width: ${ctrl.getCardWidth()?c}px;</#if>margin-bottom: 10px;">
                    <el-card shadow="always" :class="[ item.isselected === true ? 'isselected' : false, 'single-card-data' ]" @click.native="handleClick(item)" @dblclick.native="handleDblClick(item)">
  <#if ctrl.getItemPSLayoutPanel()??>
    <#assign panel = ctrl.getItemPSLayoutPanel()>
                        <@ibizindent blank=24>
                        ${P.getCtrlCode(panel, 'CONTROL.html').code}
                        </@ibizindent>
  <#elseif ctrl.itemRender??>
                        ${ctrl.itemRender.code}
  <#else>
                        <div class="data-view-item">
                            <img v-if="item.srficonpath" :src="item.srficonpath" class="single-card-img" />
                            <img v-else src="/assets/img/noimage.png" class="single-card-img" />
                            <div class="single-card-default">
                                <Tooltip :content="item.srfmajortext">
                                {{item.srfmajortext}}
                                </Tooltip>
                            </div>
                        </div>
                        <div class="data-view-item-action">
                            <template v-for="(action,index) in Object.keys(actionModel)">
                                <button type="info" :key="index" v-show="item[action].visabled" :disabled="item[action].disabled" @click="uiAction(item, action, $event)">
                                    <i :class="actionModel[action].icon" style="margin-right:2px;"></i>
                                    <span>{{actionModel[action].caption}}</span>
                                </button>
                            </template>
                        </div>
    </#if>
                    </el-card>
                </i-col>
            </a>
        <#elseif ctrl.isEnableGroup?? && ctrl.isEnableGroup()>
            <el-collapse>
                <el-collapse-item v-for="(group,index) in groupData" :key="index">
                    <template slot="title">
                    <div style="margin: 0 0 0 12px;"><b>{{group.group}}</b></div>
                    </template>
                    <div v-if="group.children.length > 0">
                        <a v-for="(item,i) in group.children" :key="i" :href="item.starturl">
                            <i-col  style="min-height: 170px;margin-bottom: 10px;">
                                <el-card shadow="always" :class="[ item.isselected === true ? 'isselected' : false, 'single-card-data' ]" @click.native="handleClick(item)" @dblclick.native="handleDblClick(item)">
                                <#if ctrl.getItemPSLayoutPanel()??>
                                    <#assign panel = ctrl.getItemPSLayoutPanel()>
                                    <@ibizindent blank=24>
                                    ${P.getCtrlCode(panel, 'CONTROL.html').code}
                                    </@ibizindent>
                                <#elseif ctrl.itemRender??>
                                    ${ctrl.itemRender.code}
                                <#else>
                                    <div class="data-view-item">
                                        <img v-if="item.srficonpath" :src="item.srficonpath" class="single-card-img" />
                                        <img v-else src="/assets/img/noimage.png" class="single-card-img" />
                                        <div class="single-card-default">
                                            <Tooltip :content="item.srfmajortext">
                                            {{item.srfmajortext}}
                                            </Tooltip>
                                        </div>
                                    </div>
                                    <div class="data-view-item-action">
                                        <template v-for="(action,index) in Object.keys(actionModel)">
                                            <button type="info" :key="index" v-show="item[action].visabled" :disabled="item[action].disabled" @click="uiAction(item, action, $event)">
                                                <i :class="actionModel[action].icon" style="margin-right:2px;"></i>
                                                <span>{{actionModel[action].caption}}</span>
                                            </button>
                                        </template>
                                    </div>
                                </#if>
                                </el-card>
                            </i-col>
                        </a>
                    </div>
                    <div v-else class="item-nodata">
                        {{ $t('<#if langbase??>${langbase}.nodata</#if>') }}
                    </div>
                </el-collapse-item>
            </el-collapse>
        </#if>
        <#if ctrl.getBatchPSDEToolbar?? && ctrl.getBatchPSDEToolbar()??>
            <div class="drag-filed" @mousedown="down">
                <row class='dataview-pagination'>
                    <div v-show="flag" class="batch-toolbar">
                    <#assign batchToolbar = ctrl.getBatchPSDEToolbar()/>
                    <@ibizindent blank=12>
                    ${P.getCtrlCode(batchToolbar, 'CONTROL.html').code}
                    </@ibizindent>
                    </div>
                    <div class="dataview-pagination-icon">
                        <Icon type="md-code-working" @click="onClick"/>
                    </div>
                </row>
            </div>
        </#if>
        </row>
        <div v-show="items.length == 0" class="app-data-empty">
        {{ $t('<#if langbase??>${langbase}.nodata</#if>') }}
        <#if ctrl.getQuickPSDEToolbar?? && ctrl.getQuickPSDEToolbar()??>
            <span class="quick-toolbar">
                <#assign quickToolbar = ctrl.getQuickPSDEToolbar()/>
                <@ibizindent blank=12>
                ${P.getCtrlCode(quickToolbar, 'CONTROL.html').code}
                </@ibizindent>
            </span>
        </#if>
        </div>
        <el-backtop target=".content-container .app-data-view"></el-backtop> 
  </div>
</#if>
</template>
<#assign import_block>
import CodeListService from "@/codelist/codelist-service";
</#assign>
<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER-BASE.vue.ftl
</#ibizinclude>

    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */  
    public codeListService:CodeListService = new CodeListService();

    /**
     * 界面UI服务对象
     *
     * @type {${srfclassname('${appde.getCodeName()}')}UIService}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */  
    public appUIService:${srfclassname('${appde.getCodeName()}')}UIService = new ${srfclassname('${appde.getCodeName()}')}UIService();

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getDatas(): any[] {
        return this.selections;
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getData(): any {
        return null;
    }

    /**
     * 是否默认选中第一条数据
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop({ default: false }) public isSelectFirstDefault!: boolean;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public createAction!: string;

    /**
     * 部件行为--remove
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public removeAction!: string;

    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public updateAction!: string;

    /**
     * 部件行为--fetch
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public fetchAction!: string;

<#if view.getPSAppViewLogics?? && view.getPSAppViewLogics()??>
  <#list view.getPSAppViewLogics() as logic>
    <#if logic.getPFLogicCodeType() == 'APP_NEWDATA'>
    /**
     * 打开新建数据视图
     *
     * @type {any}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public newdata: any;
    </#if>
    <#if logic.getPFLogicCodeType() == 'APP_OPENDATA'>
    /**
     * 打开编辑数据视图
     *
     * @type {any}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public opendata: any;
    </#if>
  </#list>
</#if>

    /**
     * this引用
     *
     * @type {number}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public thisRef: any = this;

<#if ctrl.isEnableGroup?? && ctrl.isEnableGroup()>
    /**
     * 分组属性
     * 
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public groupField: string = "<#if ctrl.getGroupPSDEField?? && ctrl.getGroupPSDEField()??>${ctrl.getGroupPSDEField().getCodeName()?lower_case}</#if>";

    /**
     * 分组属性是否配置代码表
     * 
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public groupFieldCodelist: boolean = <#if ctrl.getGroupPSDEField()?? && ctrl.getGroupPSDEField().getPSCodeList?? && ctrl.getGroupPSDEField().getPSCodeList()??>true<#else>false</#if>;

    /**
     * 分组数据
     * 
     * @type {Array<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public groupData: Array<any> = [];
    
    /**
     * 分组模式
     * 
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public groupMode: string = "<#if ctrl.getGroupMode?? && ctrl.getGroupMode()??>${ctrl.getGroupMode()}</#if>";

    /**
     * 分组方法
     * 
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public group(){
        let _this:any = this;
        if(_this.drawGroup && _this.drawGroup instanceof Function && Object.is(_this.groupMode,"AUTO")){
            _this.drawGroup();
        }else if(_this.drawCodelistGroup && _this.drawCodelistGroup instanceof Function && Object.is(_this.groupMode,"CODELIST")){
            _this.drawCodelistGroup();
        }
    }
</#if>
    /**
     * 拖拽元素对象
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public dragEle:any;


    /**
     * 拖拽后位置left
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public leftP:any;

    /**
     * 拖拽后位置top
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public topP:any;

    /**
     * 拖拽标识
     * 
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public dragflag:boolean=false;

    /**
     * 为拖拽不是点击
     * 
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public moveflag:boolean = false;
<#if ctrl.getGroupMode?? && ctrl.getGroupMode() == 'CODELIST'>

    /**
     * 分组代码表
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */ 
    public groupCodelist: any = {<#if ctrl.getGroupPSCodeList?? && ctrl.getGroupPSCodeList()??>type:'${ctrl.getGroupPSCodeList().getCodeListType()}',tag:'${ctrl.getGroupPSCodeList().getCodeName()}'</#if>};

    /**
     * 根据分组代码表绘制分组列表
     * 
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public async drawCodelistGroup(){
        let groups: Array<any> = [];
        let fields: Array<any> = [];
        let groupTree:Array<any> = [];
        let data:Array<any> = [...this.items];
        if(Object.keys(this.groupCodelist).length > 0){
            let groupCodelist: any = await this.codeListService.getDataItems(this.groupCodelist);
            groups = Util.deepCopy(groupCodelist);
        }
        if(groups.length == 0){
            console.warn("分组数据无效");
        }
        groups.forEach((group: any,i: number)=>{
            let children:Array<any> = [];
            data.forEach((item: any,j: number)=>{
                if(this.groupFieldCodelist){
                    if(Object.is(group.label,item[this.groupField])) {
                        children.push(item);
                    }
                }else if(Object.is(group.value,item[this.groupField])){
                    children.push(item);
                }
            });
            const tree: any ={
                group: group.label,
                children: children
            }
            groupTree.push(tree);
        });
        let child:Array<any> = [];
        data.forEach((item: any)=>{
            let i: number = 0;
            if(this.groupFieldCodelist){
                i = groups.findIndex((group: any)=>Object.is(group.label,item[this.groupField]));
            }else{
                i = groups.findIndex((group: any)=>Object.is(group.value,item[this.groupField]));
            }
            if(i < 0){
                child.push(item);
            }
        })
        const Tree: any = {
            group: this.$t('app.commonWords.other'),
            children: child
        }
        if(child && child.length > 0){
            groupTree.push(Tree);
        }
        this.groupData = [...groupTree];
    }
</#if>

<#if ctrl.getGroupMode?? && ctrl.getGroupMode() == 'AUTO'>
    /**
     * 绘制分组列表
     * 
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public async drawGroup(){
        let data:Array<any> = [...this.items];
        let groups:Array<any> = [];
        let fields: Array<any> = [];
        data.forEach((item: any)=>{
            if(item.hasOwnProperty(this.groupField)){
                groups.push(item[this.groupField]);
            }
        });
        groups = [...new Set(groups)];
        if(groups.length == 0){
            console.warn("分组数据无效");
        }
        let groupTree:Array<any> = [];
        groups.forEach((group: any,i: number)=>{
            let children:Array<any> = [];
            data.forEach((item: any,j: number)=>{
                if(Object.is(group,item[this.groupField])){
                    children.push(item);
                }
            });
            group = group ? group : this.$t('app.commonWords.other');
            const tree: any ={
                group: group,
                children: children
            }
            groupTree.push(tree);
        });
        this.groupData = [...groupTree];
    }
</#if>
    /**
     * 是否单选
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public isSingleSelect?: boolean;
    
    <#if ctrl.getQuickPSDEToolbar?? && ctrl.getQuickPSDEToolbar()??>
      <#assign quickToolbar = ctrl.getQuickPSDEToolbar()/>
      ${P.getCtrlCode(quickToolbar, 'CONTROL.vue').code}
    </#if>

    <#if ctrl.getBatchPSDEToolbar?? && ctrl.getBatchPSDEToolbar()??>
      <#assign batchToolbar = ctrl.getBatchPSDEToolbar()/>
      ${P.getCtrlCode(batchToolbar, 'CONTROL.vue').code}
    </#if>

    /**
     * 数据
     *
     * @type {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public items: any[] = [];

    /**
     * 操作栏模型数据
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */ 
    public actionModel:any ={
    <#if ctrl.getPSDEDataViewItems?? && ctrl.getPSDEDataViewItems()??>
    <#list ctrl.getPSDEDataViewItems() as dataViewItem>
        <#if dataViewItem.getPSDEUIActionGroup?? && dataViewItem.getPSDEUIActionGroup()??>
         <#assign UIActionGrop = dataViewItem.getPSDEUIActionGroup() />
            <#if UIActionGrop.getPSUIActions?? && UIActionGrop.getPSUIActions()??>
            <#list UIActionGrop.getPSUIActions() as UIAction >
             "${UIAction.getUIActionTag()}":{name:"${UIAction.getUIActionTag()}",icon:"<#if UIAction.getPSSysImage()??><#assign img=UIAction.getPSSysImage() /><#if img.getCssClass()?? && (img.getCssClass()?length gt 0)>${img.getCssClass()}</#if></#if>",caption:"${UIAction.getCaption()}",disabled: false, visabled: true,noprivdisplaymode:<#if UIAction.getNoPrivDisplayMode(view)??>${UIAction.getNoPrivDisplayMode(view)}</#if>,dataaccaction: "<#if UIAction.getDataAccessAction()??>${UIAction.getDataAccessAction()}</#if>", actiontarget: "${UIAction.getActionTarget()}"},
            </#list>
            </#if>
        </#if>
    </#list>
    </#if>
    };

    /**
     * 是否支持分页
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public isEnablePagingBar: boolean = ${ctrl.isEnablePagingBar()?c};;

    /**
     * 总条数
     *
     * @type {number}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public totalRecord: number = 0;

    /**
     * 加载的数据是否附加在items之后
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public isAddBehind:boolean = false;

    /**
     * 选中数组
     * @type {Array<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public selections: Array<any> = [];

    /**
     * 当前页
     *
     * @type {number}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public curPage: number = 1;

    /**
     * 分页条数
     *
     * @type {number}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public limit: number = ${ctrl.getPagingSize()?c};

    /**
     * 排序方向
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */    
    public sortDir:string = '<#if ctrl.getMinorSortDir()??>${ctrl.getMinorSortDir()?lower_case}</#if>';

    /**
     * 排序字段
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */    
    public sortField: string = '<#if ctrl.getMinorSortPSDEF()??>${ctrl.getMinorSortPSDEF().getCodeName()?lower_case}</#if>';

<#if hasSortBar>
    <#if ctrl.getPSDEDataViewDataItems?? && ctrl.getPSDEDataViewDataItems()??>
    /**
     * 排序模型数据集
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */  
    public sortModel: any[] = [
        <#list ctrl.getPSDEDataViewDataItems() as dataItem>
            <#if dataItem.getPSAppDEField?? && dataItem.getPSAppDEField()?? && !dataItem.getPSAppDEField().isKeyField()>
                <#if !P.exists("sort", dataItem.getPSDEField().getCodeName(), "") >
        '${dataItem.getPSDEField().getCodeName()?lower_case}'<#if dataItem_has_next>,</#if>
                </#if>
            </#if>
        </#list>
    ]
    </#if>
</#if>

    /**
     * 应用状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public appStateEvent: Subscription | undefined;

    /**
     * 默认隐藏批量操作工具栏
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public flag: boolean = false;

    /**
     * 更改批量操作工具栏显示状态
     *
     * @param $event
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public onClick($event: any){
        if(!this.moveflag){
            this.flag = !this.flag;
        } 
        this.moveflag = false;
    }

    /**
     * 排序点击事件
     * @param {string} field 属性名
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public sortClick(field:string) {
        if(this.sortField !== field){
            this.sortField = field;
            this.sortDir = 'asc';
        }else if(this.sortDir === 'asc'){
            this.sortDir = 'desc';
        }else if(this.sortDir === 'desc'){
            this.sortDir = '';
        }else{
            this.sortDir = 'asc';
        }
        this.refresh();
    }

    /**
     * 排序class变更
     * @param {string} field 属性名
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getsortClass(field:string) {
        if(this.sortField !== field || this.sortDir === ''){
            return '';
        }else if(this.sortDir === 'asc'){
            return 'sort-ascending'
        }else if(this.sortDir === 'desc'){
            return 'sort-descending'
        }
    }

    /**
     * Vue声明周期，组件挂载完毕
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public mounted () {
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     *
     *  @memberof ${srfclassname('${ctrl.codeName}')}Base
     */    
    public afterMounted(){
        this.$el.addEventListener('scroll', ()=> {
            <#if ctrl.getBatchPSDEToolbar?? && ctrl.getBatchPSDEToolbar()??>
            let el: any = this.$el.getElementsByClassName('dataview-pagination')[0];
            el.style.top = 40 + this.$el.scrollTop + 'px';
            </#if>
            <#if ctrl.isEnablePagingBar()>
            if( this.$el.scrollTop +  this.$el.clientHeight  >=  this.$el.scrollHeight) {
                this.loadMore();
            }
            </#if>
        })
    }



    /**
     * Vue声明周期，组件创建完毕
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public created() {
        this.afterCreated();
        this.$nextTick(()=>{
            this.mouseEvent();
        })
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof ${srfclassname('${ctrl.codeName}')}Base
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(this.name, tag)) {
                    return;
                }
                if (Object.is(action,'load')) {
                    this.refresh(data)
                }
                if (Object.is(action,'filter')) {
                    this.refresh(data)
                }
            });
        }
        if(AppCenterService && AppCenterService.getMessageCenter()){
            this.appStateEvent = AppCenterService.getMessageCenter().subscribe(({ name, action, data }) =>{
                if(!Object.is(name,"${ctrl.getPSAppDataEntity().getCodeName()}")){
                    return;
                }
                if(Object.is(action,'appRefresh')){
                    this.refresh([data]);
                }
            })
        }
    }

    /**
     * 鼠标移动+放下
     * 
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public mouseEvent(){
        this.dragEle = document.getElementsByClassName('drag-filed')[0];
        document.onmousemove=(e:any)=>{
            if(this.dragflag){
                this.dragEle.style.left = (e.clientX - this.leftP) + 'px';
                this.dragEle.style.top = (e.clientY - this.topP) + 'px';
                this.moveflag = true;
            }
        }
        document.onmouseup=(e:any)=>{
            this.dragflag = false;
        }
    }

    /**
     * mousedown事件
     * 
     * @param $event
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public down(e:any){
        this.leftP = e.clientX - this.dragEle.offsetLeft;
        this.topP = e.clientY - this.dragEle.offsetTop;
        this.dragflag = true;
    }

    /**
	 * 加载更多
	 *
	 * @memberof ${srfclassname('${ctrl.codeName}')}Base
	 */
    public loadMore(){
        if(this.totalRecord>this.items.length)
        {
            this.curPage = ++this.curPage;
            this.isAddBehind = true;
            this.load({});
        }
    }

    /**
     * 刷新
     *
     * @param {*} [args={}]
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public refresh(args?: any) {
        this.curPage = 1;
        this.load(args, true);
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if(this.appStateEvent){
            this.appStateEvent.unsubscribe();
        }
        <#if destroyed_block??>
        ${destroyed_block}
        </#if>
    }

    /**
     * 表格数据加载
     *
     * @public
     * @param {*} [arg={}]
     * @param {boolean} [isReset=false] 是否重置items
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public load(opt: any = {}, isReset: boolean = false): void {
        if(!this.fetchAction){
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: '${view.getName()}' + (this.$t('app.list.notConfig.fetchAction') as string) });
            return;
        }      
        const arg: any = {...opt};
        const page: any = {};
        if (this.isEnablePagingBar) {
            Object.assign(page, { page: this.curPage-1, size: this.limit });
        }
        // 设置排序
        if (!Object.is(this.sortDir, '') && !Object.is(this.sortField, '')) {
          const sort: string = this.sortField+","+this.sortDir;
            Object.assign(page, { sort: sort });
        }
        Object.assign(arg, page);
        const parentdata: any = {};
        this.$emit('beforeload', parentdata);
        Object.assign(arg, parentdata);
        let tempViewParams:any = parentdata.viewparams?parentdata.viewparams:{};
        Object.assign(tempViewParams,JSON.parse(JSON.stringify(this.viewparams)));
        Object.assign(arg,{viewparams:tempViewParams});
        const post: Promise<any> = this.service.search(this.fetchAction,JSON.parse(JSON.stringify(this.context)), arg, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response || response.status !== 200) {
                if (response.data && response.data.message) {
                    this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: response.data.message });
                }
                return;
            }
            const data: any = response.data;
            if(!this.isAddBehind){
                this.items = [];
            }
            if (Object.keys(data).length > 0) {
                let datas = JSON.parse(JSON.stringify(data));
                datas.map((item: any) => {
                    Object.assign(item, { isselected: false });
                });
                this.totalRecord = response.total;
                if(isReset){
                    this.items = datas;
                }else{
                    this.items.push(...datas);
                }
            }
            this.isAddBehind = false;
            this.items.forEach((item: any) => {
                Object.assign(item,this.getActionState(item));    
            })
            this.$emit('load', this.items);
            //在导航视图中，如已有选中数据，则右侧展开已选中数据的视图，如无选中数据则默认选中第一条
            if(this.isSelectFirstDefault){
                if(this.selections && this.selections.length > 0){
                    this.selections.forEach((select: any)=>{
                        const index = this.items.findIndex((item:any) => Object.is(item.srfkey,select.srfkey));
                        if(index != -1){
                            this.handleClick(this.items[index]);
                        }
                    })
                }else{
                    this.handleClick(this.items[0]);
                } 
            }
            <#if ctrl.isEnableGroup?? && ctrl.isEnableGroup()>
            this.group();
            </#if>
        }, (response: any) => {
            if (response && response.status === 401) {
                return;
            }
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: response.data && response.data.message ? response.data.message : "" });
        });
    }

    /**
     * 删除
     *
     * @param {any[]} datas
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public async remove(datas: any[]): Promise<any> {
        if(!this.removeAction){
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: '${view.getName()}' + (this.$t('app.gridpage.notConfig.removeAction') as string) });
            return;
        }
        let _datas:any[] = [];
        datas.forEach((record: any, index: number) => {
            if (Object.is(record.srfuf, '0')) {
                this.items.some((val: any, num: number) =>{
                    if(JSON.stringify(val) == JSON.stringify(record)){
                        this.items.splice(num,1);
                        return true;
                    }
                }); 
            }else{
               _datas.push(datas[index]);
            }
        });
        if (_datas.length === 0) {
            return;
        }
        let dataInfo = '';
        _datas.forEach((record: any, index: number) => {
            let srfmajortext = record.srfmajortext;
            if (index < 5) {
                if (!Object.is(dataInfo, '')) {
                    dataInfo += '、';
                }
                dataInfo += srfmajortext;
            } else {
                return false;
            }
        });

        if (_datas.length < 5) {
            dataInfo = dataInfo + ' ' + (this.$t('app.dataView.sum') as string) + _datas.length + (this.$t('app.dataView.data') as string);
        } else {
            dataInfo = dataInfo + '...' + ' ' + (this.$t('app.dataView.sum') as string) + _datas.length + (this.$t('app.dataView.data') as string);
        }

        const removeData = () => {
            let keys: any[] = [];
            _datas.forEach((data: any) => {
                keys.push(data.srfkey);
            });
            let _removeAction = keys.length > 1 ? 'removeBatch' : this.removeAction ;
            const context:any = JSON.parse(JSON.stringify(this.context));
            const post: Promise<any> = this.service.delete(_removeAction,Object.assign(context,{ ${ctrl.getPSAppDataEntity().codeName?lower_case}: keys.join(';') }),Object.assign({ ${ctrl.getPSAppDataEntity().codeName?lower_case}: keys.join(';') },{viewparams:this.viewparams}), this.showBusyIndicator);
            return new Promise((resolve: any, reject: any) => {
                post.then((response: any) => {
                    if (!response || response.status !== 200) {
                        this.$Notice.error({ title: '', desc: (this.$t('app.commonWords.delDataFail') as string) + ',' + response.info });
                        return;
                    } else {
                        this.$Notice.success({ title: '', desc: (this.$t('app.commonWords.deleteSuccess') as string) });
                    }
                    //删除items中已删除的项
                    _datas.forEach((data: any) => {
                      this.items.some((item:any,index:number)=>{
                            if(Object.is(item.srfkey,data.srfkey)){
                                this.items.splice(index,1);
                                <#if ctrl.isEnableGroup?? && ctrl.isEnableGroup()>
                                this.group();
                                </#if>
                                return true;
                            }
                        });
                    });
                    this.$emit('remove', null);
                    this.selections = [];
                    resolve(response);
                }).catch((response: any) => {
                    if (response && response.status === 401) {
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: (this.$t('app.commonWords.sysException') as string) });
                        reject(response);
                        return;
                    }
                    reject(response);
                });
            });
        }

        dataInfo = dataInfo.replace(/[null]/g, '').replace(/[undefined]/g, '').replace(/[ ]/g, '');
        this.$Modal.confirm({
            title: (this.$t('app.commonWords.warning') as string),
            content: (this.$t('app.gridpage.confirmDel') as string) + ' ' + dataInfo + '，' + (this.$t('app.gridpage.notRecoverable') as string),
            onOk: () => {
                removeData();
            },
            onCancel: () => { }
        });
        return removeData;
    }


    /**
     * 保存
     *
     * @param {*} $event
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public async save(args: any[], params?: any, $event?: any, xData?: any){
        let _this = this;
        let successItems:any = [];
        let errorItems:any = [];
        let errorMessage:any = [];
        for (const item of _this.items) {
            try {
                if(Object.is(item.rowDataState, 'create')){
                    if(!this.createAction){
                        this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: '${view.getName()}' + (this.$t('app.list.notConfig.createAction') as string) });
                    }else{
                      Object.assign(item,{viewparams:this.viewparams});
                      let response = await this.service.add(this.createAction, JSON.parse(JSON.stringify(this.context)),item, this.showBusyIndicator);
                      successItems.push(JSON.parse(JSON.stringify(response.data)));
                    }
                }else if(Object.is(item.rowDataState, 'update')){
                    if(!this.updateAction){
                        this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: '${view.getName()}' + (this.$t('app.list.notConfig.updateAction') as string) });
                    }else{
                        Object.assign(item,{viewparams:this.viewparams});
<#if de??>
                        if(item.${appde.getCodeName()?lower_case}){
                            Object.assign(this.context,{${appde.getCodeName()?lower_case}:item.${appde.getCodeName()?lower_case}});
                        }
</#if>
                        let response = await this.service.add(this.updateAction,JSON.parse(JSON.stringify(this.context)),item, this.showBusyIndicator);
                        successItems.push(JSON.parse(JSON.stringify(response.data)));
                    }
                }
            } catch (error) {
                errorItems.push(JSON.parse(JSON.stringify(item)));
                errorMessage.push(error);
            }
        }
        this.$emit('save', successItems);
        this.refresh();
        if(errorItems.length === 0){
            this.$Notice.success({ title: '', desc: (this.$t('app.commonWords.saveSuccess') as string) });
        }else{
          errorItems.forEach((item:any,index:number)=>{
            this.$Notice.error({ title: (this.$t('app.commonWords.saveFailed') as string), desc: item.majorentityname + (this.$t('app.commonWords.saveFailed') as string) + '！' });
            console.error(errorMessage[index]);
          });
        }
        return successItems;
    }

    /**
     * 面板数据变化处理事件
     * @param {any} item 当前卡片数据
     * @param {any} $event 面板事件数据
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public onPanelDataChange(item:any,$event:any) {
        Object.assign(item, $event, {rowDataState:'update'});
    }

    /**
     * 选择数据
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     *
     */
    public handleClick(args: any) {
        args.isselected = !args.isselected;
        if(this.isSingleSelect) {
            this.items.forEach((item:any) =>{
                if(item.srfkey !== args.srfkey){
                    item.isselected =false;
                }
            })
        }
        this.selectchange();
    }

    /**
     * 双击数据
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     *
     */
    public handleDblClick(args: any) {
        this.$emit('rowdblclick', args);
    }

    /**
     * 触发事件
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     *
     */
    public selectchange() {
        this.selections = [];
        this.items.map((item: any) => {
            if (item.isselected) {
                this.selections.push(item);
            }
        });
        this.$emit('selectionchange', this.selections);
    }

    /**
     * 操作列界面行为
     *
     * @param {*} data
     * @param {*} tag
     * @param {*} $event
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
	public uiAction(data: any, tag: any, $event: any) {
        $event.stopPropagation();
        <#if ctrl.getPSAppViewLogics()??>
        <#list ctrl.getPSAppViewLogics() as logic>
        <#if logic.getPSAppViewUIAction().getPSUIAction()??>
        <#assign action = logic.getPSAppViewUIAction().getPSUIAction()>
        if(Object.is('${action.getUIActionTag()}', tag)) {
            this.${logic.getName()}(data, tag, $event);
        }
        </#if>
        </#list>
        </#if>
    }

    /**
     * 获取界面行为权限状态
     *
     * @param {*} data 当前列表行数据
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getActionState(data:any){
        let tempActionModel:any = JSON.parse(JSON.stringify(this.actionModel));
        let targetData:any = this.transformData(data);
        ViewTool.calcActionItemAuthState(targetData,tempActionModel,this.appUIService);
        return tempActionModel;
    }

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_BOTTOM-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL-BASE.style.ftl
</#ibizinclude>