<#ibizinclude>
../@MACRO/MODEL/MODEL_HEADER.ts.ftl
</#ibizinclude>

	/**
	 * 是否是实体数据导出
	 *
	 * @returns {any[]}
	 * @memberof ${srfclassname('${ctrl.getCodeName()}')}${srfclassname('${ctrl.name}')}Mode
	 */
	public isDEExport: boolean = false;

	/**
	 * 获取数据项集合
	 *
	 * @returns {any[]}
	 * @memberof ${srfclassname('${ctrl.getCodeName()}')}${srfclassname('${ctrl.name}')}Mode
	 */
	public getDataItems(): any[] {
    if(this.isDEExport){
		  return [
<#--  实体导出数据项  -->
<#if ctrl.getPSDEDataExport?? && ctrl.getPSDEDataExport()?? && ctrl.getPSDEDataExport().getPSDEDataExportItems()??>
  <#list ctrl.getPSDEDataExport().getPSDEDataExportItems() as dataitem>
        {
          name: '${dataitem.getName()}',
    <#if dataitem.getPSDEField()??>
          prop: '${dataitem.getPSDEField().getCodeName()?lower_case}',
          dataType: '${dataitem.getPSDEField().getDataType()}',
    </#if>
    <#if ctrl.getPSDEGridEditItems()??>
    <#list ctrl.getPSDEGridEditItems() as editItem>
    <#if editItem.getName() == dataitem.getName()>
    <#if editItem.isEditable()>
          isEditable:${editItem.isEditable()?c}
    </#if>
    </#if>
    </#list>
    </#if>
        },
  </#list>
</#if>
      ]
    }else{
		  return [
<#--  表格数据项  -->
<#if ctrl.getPSDEGridDataItems()??>
  <#list ctrl.getPSDEGridDataItems() as dataitem>
        {
          name: '${dataitem.getName()}',
    <#if dataitem.getPSDEField()??>
          prop: '${dataitem.getPSDEField().getCodeName()?lower_case}',
          dataType: '${dataitem.getPSDEField().getDataType()}',
    </#if>
    <#if ctrl.getPSDEGridEditItems()??>
    <#list ctrl.getPSDEGridEditItems() as editItem>
    <#if editItem.getName() == dataitem.getName()>
    <#if editItem.isEditable()>
          isEditable:${editItem.isEditable()?c}
    </#if>
    </#if>
    </#list>
    </#if>
        },
  </#list>
</#if>
<#--  关联主实体的主键  -->
<#if ctrl.getPSAppDataEntity()??>
  <#assign appDataEntity = ctrl.getPSAppDataEntity() />
  <#if appDataEntity.isMajor() == false && appDataEntity.getMinorPSAppDERSs()??>
    <#list appDataEntity.getMinorPSAppDERSs() as minorAppDERSs>
      <#if minorAppDERSs.getMajorPSAppDataEntity()??>
      <#assign majorAppDataEntity = minorAppDERSs.getMajorPSAppDataEntity() />
        {
          name: '${majorAppDataEntity.getCodeName()?lower_case}',
          prop: '<#if majorAppDataEntity.getPSDER1N?? && majorAppDataEntity.getPSDER1N()??>${majorAppDataEntity.getPSDER1N().getPSPickupDEField().getCodeName()?lower_case}<#else>${majorAppDataEntity.getKeyPSAppDEField().getCodeName()?lower_case}</#if>',
          dataType: 'FONTKEY',
        },
      </#if>
    </#list>
  </#if>
</#if>
<#if ctrl.getPSDEGridDataItems()??>
  <#list ctrl.getPSDEGridDataItems() as dataitem>
	<#-- 界面主键标识 -->
  <#if dataitem.getPSDEField?? && dataitem.getPSDEField()??>
	<#if !P.exists("importService", dataitem.getPSDEField().getId(), "")>
	 	<#if dataitem.getPSDEField().isKeyDEField() == true>
        {
          name: '${ctrl.getPSAppDataEntity().getCodeName()?lower_case}',
          prop: '${dataitem.getPSDEField().getCodeName()?lower_case}',
        },
	 	</#if>
	</#if>
  </#if>
  </#list>
</#if>
<#if view.hasPSControl('searchform')>
${P.getCtrlCode('searchform', 'MODEL_CONTENT.ts').code}
</#if>
        {
          name:'size',
          prop:'size',
          dataType: 'QUERYPARAM'
        },
        {
          name:'query',
          prop:'query',
          dataType: 'QUERYPARAM'
        },
        {
          name:'filter',
          prop:'filter',
          dataType: 'QUERYPARAM'
        },
        {
          name:'page',
          prop:'page',
          dataType: 'QUERYPARAM'
        },
        {
          name:'sort',
          prop:'sort',
          dataType: 'QUERYPARAM'
        },
        {
          name:'srfparentdata',
          prop:'srfparentdata',
          dataType: 'QUERYPARAM'
        },
        // 前端新增修改标识，新增为"0",修改为"1"或未设值
        {
          name: 'srffrontuf',
          prop: 'srffrontuf',
          dataType: 'TEXT',
        },
        // 预置工作流数据字段
        {
          name: 'srfprocessdefinitionkey',
          prop: 'srfprocessdefinitionkey',
          dataType: 'TEXT'
        },
        {
          name: 'srftaskdefinitionkey',
          prop: 'srftaskdefinitionkey',
          dataType: 'TEXT'
        },
        {
          name: 'srftaskid',
          prop: 'srftaskid',
          dataType: 'TEXT'
        }
      ]
    }
  }

<#ibizinclude>
../@MACRO/MODEL/MODEL_BOTTOM.ts.ftl
</#ibizinclude>